/*
  Copyright 2010-2011 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef EXPORTENGINE_H
#define EXPORTENGINE_H

#include <model/model.h>
#include <controller/KissCount.h>
#include <model/AccountAmount.h>

class KissCount;

class ExportEngine {
public:
    ExportEngine();
    ~ExportEngine();

    // Get supported file extension. Example :
    // "OFX files (*.ofx)|*.ofx"
    virtual wxString GetFileExt();

    // Handle the file
    virtual bool HandleFile(const wxString& path, User* user, Database* db, KissCount* kiss)=0;

    // Save operations (ExportEngin pre fill _accounts, _categories and _accountAmounts)
    virtual bool SaveFile(std::vector<Operation>* operations)=0;

protected:
    wxString _path;
    Database* _db;
    User* _user;
    KissCount* _kiss;

    wxString _shortExt;
    wxString _longExt;

    std::map<wxString, int> _accounts;
    std::map<wxString, int> _categories;
    std::map<AccountAmount, double, AccountAmount> _accountAmounts;
};

#endif
