/*
  Copyright 2010-2011 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef XMLIMPORTENGINE_H
#define XMLIMPORTENGINE_H

#include <libxml/parser.h>

#include "ImportEngine.h"

class XMLImportEngine : public ImportEngine {
public:
    XMLImportEngine();
    ~XMLImportEngine();

    virtual bool HandleFile(const wxString& path, User* user, Database* db, KissCount* kiss);

private:
    xmlSAXHandler _sax;

    static void XmlStartElement(void* user_data, const xmlChar* name_, const xmlChar** attrs_);
    static void LoadAccount(XMLImportEngine* _this, const char** attrs);
    static void LoadAccountAmount(XMLImportEngine* _this, const char** attrs);
    static void LoadCategory(XMLImportEngine* _this, const char** attrs);
    static void LoadOperation(XMLImportEngine* _this, const char** attrs);
};

#endif
