/*
  Copyright 2010-2011 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SEARCHBANNER_H
#define SEARCHBANNER_H

#include <wx/wx.h>
#include <wx/grid.h>
#include <wx/treectrl.h>
#include <wx/scrolwin.h>
#include "view.h"
#include "grid/CalendarEditor.h"

#include <model/model.h>

typedef void (*OnButtonEnter)(void* caller, wxCommandEvent& event);

class SearchBanner: public wxPanel
{
public:
    SearchBanner(KissCount* kiss, wxPanel* parent, void* caller=NULL, OnButtonEnter enterCallback=NULL);
    ~SearchBanner();

    void OnEnter(wxCommandEvent& event);
    void OnButtonSearch(wxCommandEvent& event);
    void OnCalendarFromChange(wxCalendarEvent& event);
    void OnCalendarToChange(wxCalendarEvent& event);

    std::vector<Operation> * Search();

private:
    KissCount* _kiss;
    void* _caller;
    OnButtonEnter _enterCallback;

    std::vector<Operation> *_operations;
    wxCalendarCtrl* _calendarFrom, *_calendarTo;
    wxCheckBox *_checkDateFrom, *_checkDateTo;
    wxTextCtrl* _description, *_amountFrom, *_amountTo;
    wxCheckListBox* _category, *_account, *_optype;
    DECLARE_EVENT_TABLE();
};

#endif
