/*
  Copyright 2010-2011 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SEARCHPANEL_H
#define SEARCHPANEL_H

#include <wx/wx.h>
#include <wx/grid.h>
#include <wx/treectrl.h>
#include <wx/scrolwin.h>
#include "view.h"
#include "grid/CalendarEditor.h"
#include "grid/wxGridCellBitmapRenderer.h"
#include "grid/GridAccount.h"
#include "AccountPanel.h"
#include "SearchBanner.h"

#include <model/model.h>

class GridAccount;
class SearchBanner;

class SearchPanel: public KissPanel
{
public:
    SearchPanel(KissCount* kiss, wxUI *parent);
    ~SearchPanel();

    KissPanel* CreatePanel();
    wxBitmapButton* GetButton(int id);
    wxString GetToolTip();
    void OnShow(wxShowEvent& event);

    /* void OnEnter(wxCommandEvent& event); */
    void OnButtonSearch(wxCommandEvent& event);
    void OnOperationModified(wxGridEvent& event);

    void OnButtonChangeAccount(wxCommandEvent& event);
    void OnButtonChangeCategory(wxCommandEvent& event);
    void OnButtonRename(wxCommandEvent& event);

private:
    std::vector<Operation> *_operations;
    SearchBanner* _banner;
    GridAccount *_grid;
    wxButton* _searchButton, *_renameButton, *_changeAccountButton, *_changeCategoryButton;

    static void OnEnter(void* caller, wxCommandEvent& event);

    DECLARE_EVENT_TABLE();
};

#endif
